Bug 143505 - CAN-2004-1308 LibTIFF Directory Entry Count Integer Overflow Vulnerability
CAN-2004-1308 LibTIFF Directory Entry Count Integer Overflow Vulnerability
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: libtiff (Show other bugs)
All Linux
medium Severity high
: ---
: ---
Assigned To: Matthias Clasen
: Security
Depends On:
  Show dependency treegraph
Reported: 2004-12-21 14:08 EST by Josh Bressers
Modified: 2007-11-30 17:07 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2005-01-13 08:21:05 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Josh Bressers 2004-12-21 14:08:17 EST
LibTIFF Directory Entry Count Integer Overflow Vulnerability*

iDEFENSE Security Advisory 12.21.04*
December 21, 2004


This software provides support for the Tag Image File Format (TIFF), a*
widely used format for storing image data. Included in this software*
distribution is a library, libtiff, for reading and writing TIFF, a*
small collection of tools for doing simple manipulations of TIFF images*
on UNIX systems, and documentation on the library and tools. A small*
assortment of TIFF-related software for UNIX that has been contributed*
by others is also included.

More information is available at the following site:*


Remote exploitation of a heap-based buffer overflow vulnerability*
within the LibTIFF package could allow attackers to execute arbitrary*

The vulnerability specifically exists due to insufficient validation of*
user-supplied data when calculating the size of a directory entry. A*
TIFF file includes a number of directory entry header fields that*
describe the data in the file. Included in these entries is an entry*
count and offset value that are calculated to determine the size and*
location of the data for that entry. If the directory entry type is*
TIFF_ASCII or TIFF_UNDEFINED, the a call to CheckMalloc is made in*
order to allocate space for the entry contents as shown below from*

cp = CheckMalloc(tif, dp->tdir_count+1, 1, mesg);*
if( (ok = (cp && TIFFFetchString(tif, dp, cp))) != 0 )
    cp[dp->tdir_count] = '\0';  /* XXX */

If the tdir_count is set to 0xffffffff, the increment will cause the*
function call to allocate 0 bytes of memory and later memcpy calls will*
cause the buffer to overflow. An attacker may generate a malicious TIFF*
file which takes advantage of this unchecked calculation to execute*
arbitrary code with permissions of the user opening the TIFF file.


Remote attackers may be able to execute arbitrary code with permissions*
of the user opening the malformed TIFF file. The exposure to this*
vulnerability is mitigated by the fact that user interaction is*
required and that the user must view the malicious TIFF file in an*
application that is linked to a vulnerable version of libtiff.


iDEFENSE has confirmed the existence of this vulnerability in LibTIFF*
3.5.7 and 3.7.0.

The following vendors distribute susceptible TIFF packages within their*
respective operating system distributions:

    - Debian Linux
    - Gentoo Linux
    - RedHat Linux
    - SuSE Linux*

Only open TIFF files from trusted users or in an application not linked*
against vulnerable versions of libtiff.


The following patch will address this vulnerability:

--- tif_dirread.c.bak>--2004-12-19 21:04:00.000000000 +0300
+++ tif_dirread.c>--2004-12-19 21:04:03.000000000 +0300
@@ -71,7 +71,7 @@
 >-- * XXX: Check for integer overflow.
 >-- */
->--if (elem_size && bytes / elem_size == nmemb)
+>--if (nmemb && elem_size && bytes / elem_size == nmemb)
 >-->---cp = (char*)_TIFFmalloc(bytes);
 >--if (cp == NULL)

(the same applies for tif_fax3.c)

This patch has been incorporated into libtiff 3.7.1.


A Mitre Corp. Common Vulnerabilities and Exposures (CVE) number has not
been assigned yet.


12/17/2004  Initial vendor notification
12/17/2004  iDEFENSE clients notified
12/21/2004  Coordinated public disclosure


The discoverer of this vulnerability wishes to remain anonymous.

Get paid for vulnerability research


Copyright (c) 2004 iDEFENSE, Inc.

Permission is granted for the redistribution of this alert
electronically. It may not be edited in any way without the express
written consent of iDEFENSE. If you wish to reprint the whole or any
part of this alert in any other medium other than electronically, please
email customerservice@idefense.com for permission.

Disclaimer: The information in the advisory is believed to be accurate
at the time of publishing based on currently available information. Use
of the information constitutes acceptance for use in an AS IS condition.
There are no warranties with regard to this information. Neither the
author nor the publisher accepts any liability for any direct, indirect,
or consequential loss or damage arising from use of, or reliance on,
this information.
Comment 1 Josh Bressers 2004-12-21 14:09:16 EST
This issue should also affect RHEL2.1
Comment 3 Josh Bressers 2004-12-22 10:03:15 EST
Lifting embargo.
Comment 5 Matthias Clasen 2004-12-22 10:24:35 EST
 I have built libtiff-3.5.5-18 into dist-2.1AS-errata-candidate and
libtiff-3.5.7-21.el3 into dist-3.0E-errata-candidate.
Comment 6 Josh Bressers 2004-12-23 08:13:45 EST
attachment 109073 [details]
Contains a demo exploit for this issue.
Comment 7 Josh Bressers 2005-01-13 08:21:06 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.